---
title: Intl.Locale.prototype.caseFirst
slug: Web/JavaScript/Reference/Global_Objects/Intl/Locale/caseFirst
tags:
  - Internationalization
  - Intl
  - JavaScript
  - Property
  - Prototype
  - Reference
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <strong><code>Intl.Locale.prototype.caseFirst</code></strong> property is an accessor property that returns whether case is taken into account for the locale's collation rules.</span></p>

<h2 id="Description">Description</h2>

<p>A locale's collation rules are used to determine how strings are ordered in that locale. Certain locales use a character's case (UPPERCASE or lowercase) in the collation process. This additional rule can be expressed in a {{jsxref("Locale", "Locale's")}} <code>caseFirst</code> property.</p>

<p>There are 3 values that the <code>caseFirst</code> property can have, outlined in the table below.</p>

<h3 id="caseFirst_values"><code>caseFirst</code> values</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Value</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>upper</code></td>
   <td>Upper case to be sorted before lower case.</td>
  </tr>
  <tr>
   <td><code>lower</code></td>
   <td>Lower case to be sorted before upper case.</td>
  </tr>
  <tr>
   <td><code>false</code></td>
   <td>No special case ordering.</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<h3 id="Setting_the_caseFirst_value_via_the_locale_string">Setting the <code>caseFirst</code> value via the locale string</h3>

<p>In the <a href="https://www.unicode.org/reports/tr35/" rel="noopener">Unicode locale string spec</a>, the values that <code>caseFirst</code> represents correspond to the key <code>kf</code>. <code>kf</code> is treated as a locale string "extension subtag". These subtags add additional data about the locale, and are added to locale identifiers by using the <code>-u</code> extension key. Thus, the <code>caseFirst</code> value can be added to the inital locale identifier string that is passed into the <code>Locale</code> constructor. To add the <code>caseFirst</code> value, first add the <code>-u</code> extension key to the string. Next, add the <code>-kf</code> extension key to indicate that you are adding a value for <code>caseFirst</code>. Finally, add the <code>caseFirst</code> value to the string.</p>

<pre class="brush: js">let caseFirstStr = new Intl.Locale("fr-Latn-FR-u-kf-upper");
console.log(caseFirstStr.caseFirst); // Prints "upper"</pre>

<h3 id="Setting_the_caseFirst_value_via_the_configuration_object_argument">Setting the caseFirst value via the configuration object argument</h3>

<p>The {{jsxref("Locale/Locale", "Intl.Locale")}} constructor has an optional configuration object argument, which can be used to pass extension types. Set the <code>caseFirst</code> property of the configuration object to your desired <code>caseFirst</code> value, and then pass it into the constructor.</p>

<pre class="brush: js">let caseFirstObj= new Intl.Locale("en-Latn-US", {caseFirst: "lower"});
console.log(us12hour.caseFirst); // Prints "lower"</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ES Int Draft', '#sec-Intl.Locale.prototype.caseFirst')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("javascript.builtins.Intl.Locale.caseFirst")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Locale", "Intl.Locale")}}</li>
 <li><a href="https://github.com/unicode-org/cldr/blob/master/common/bcp47/collation.xml#L49">Unicode case first collation spec</a></li>
</ul>
